/************************************************************************/
/* Author: 	Hirotaka Miura.						*/
/* Contact: 	Hirotaka.Miura@gmail.com.				*/
/************************************************************************/

/************************************************************************/
/* 05/05/2011: 	Modified.						*/
/* 04/24/2011: 	Previouly modified.					*/
/* 04/22/2011: 	Created.							*/
/************************************************************************/

/************************************************************************/
/* Program: 	write().						*/
/* Function: 	Write out matrix to specified path and format.		*/
/************************************************************************/
mata:
void write(string scalar s, transmorphic matrix X
  ,|string scalar delimiter, string scalar noquotes){
  /* Declare variables.							*/
  transmorphic scalar fh /* File output handle.				*/
  real scalar i,j /* Row/column counter.				*/
  string matrix S /* String version of input matrix.			*/
  string scalar filename /* File name. 					*/
  string scalar w /* Write-out string.					*/
  /* Begin program.							*/
  filename=s			
  /* Delete file if it already exists.					*/
  unlink(filename)
  /* Open file and write to it.						*/
  fh=fopen(filename,"w")
  /* If input matrix numeric, convert to string matrix.			*/
  if(isstring(X)==0) S=strofreal(X,"%50.0g")
  else S=X
  /* Set delimiter to tab by default.					*/
  if(delimiter=="") delimiter=char(9)
  /**********************************************************************/
  /* Vector case.							*/
  /**********************************************************************/
  /***** Input vector numeric.						*/
  if(cols(X)==1 & isstring(X)==0){
    for(i=1;i<=rows(S);i++){
      w=S[i,1]
      fput(fh,w)
    }
  }
  /***** Input vector string.						*/
  else if(cols(X)==1 & isstring(X)==1){
    for(i=1;i<=rows(S);i++){
      if(noquotes=="") w=`"""'+S[i,1]+`"""'
      else w=S[i,1]
      fput(fh,w)
    }
  }  
  /**********************************************************************/
  /* Matrix case.							*/
  /**********************************************************************/
  /***** Input matrix numeric.						*/
  else if(cols(X)>1 & isstring(X)==0){
    for(i=1;i<=rows(S);i++){
      w=invtokens(S[i,.],delimiter)
      fput(fh,w)
    }
  }
  /***** Input matrix string.						*/
  else if(cols(X)>1 & isstring(X)==1){
    for(i=1;i<=rows(S);i++){
      for(j=1;j<=cols(S);j++){
        if(j==1){
          if(noquotes=="") w=`"""'+S[i,j]+`"""'+delimiter
          else w=S[i,j]+delimiter
        }
        else if(j<cols(S)){
          if(noquotes=="") w=w+`"""'+S[i,j]+`"""'+delimiter
          else w=w+S[i,j]+delimiter
        }
        else{
          if(noquotes=="") w=w+`"""'+S[i,j]+`"""'
          else w=w+S[i,j]
        }
      }      
      fput(fh,w)
    }
  }
    
  /* Close CSV file.							*/
  fclose(fh)
}
end


